From 3415e6db3122341662c1e59f01ffd9c8709eff76 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 14 2020 00:32:31 +0000
Subject: [PATCH 1370/2232] Add github link to website sidebar


---

diff --git a/book/.gitignore b/book/.gitignore
index 690b5b8..7277507 100644
--- a/book/.gitignore
+++ b/book/.gitignore
@@ -1,2 +1,3 @@
 /build
 /mdbook
+/node_modules
diff --git a/book/build.js b/book/build.js
new file mode 100755
index 0000000..a9278db
--- /dev/null
+++ b/book/build.js
@@ -0,0 +1,37 @@
+#!/usr/bin/env node
+
+const fs = require('fs');
+const cheerio = require('cheerio');
+
+const githublink = `\
+<li class="part-title">\
+<a href="https://github.com/dtolnay/cxx">\
+<i class="fa fa-github" style="font-size:20px;padding-right:5px;padding-top:12px;position:relative;top:1px"></i>\
+https://github.com/dtolnay/cxx\
+</a>\
+</li>`;
+
+const dirs = ['build'];
+while (dirs.length) {
+  const dir = dirs.pop();
+  fs.readdirSync(dir).forEach((entry) => {
+    path = dir + '/' + entry;
+    const stat = fs.statSync(path);
+    if (stat.isDirectory()) {
+      dirs.push(path);
+      return;
+    }
+
+    if (!path.endsWith('.html')) {
+      return;
+    }
+
+    const index = fs.readFileSync(path, 'utf8');
+    const $ = cheerio.load(index, { decodeEntities: false });
+
+    $('nav#sidebar ol.chapter').append(githublink);
+
+    const out = $.html();
+    fs.writeFileSync(path, out);
+  });
+}
diff --git a/book/build.sh b/book/build.sh
index a847139..783d304 100755
--- a/book/build.sh
+++ b/book/build.sh
@@ -9,3 +9,9 @@ if [ -f ./mdbook ]; then
 else
     mdbook build
 fi
+
+if [ ! -d node_modules ]; then
+    npm install
+fi
+
+./build.js
